import operator
import numpy as np
import os
import numpy
import json
import pandas as pd
import itertools
from tqdm import tqdm


brand_lst=['olympus','nikon','canon','panasonic','leica','vivitar','sony','fujifilm','samsung','pentax','fuji']


# check for match of upc
# check for model which is immediate next of brand
# construct a list of models from the datasets and use it to look for a model in a product description
# We can use these as blocking keys too 

def get_brand(title,models):
    orig_title=title
    title=title.split()
    lst=[]

    for token in title:
    	if token in brand_lst and not token in lst :
    		lst.append(token)
    for brand in brand_lst:
    	if brand in orig_title:
    		lst.append(brand)
    if len(lst)==0:
        lst.append("na")  
    if lst[0]=='fuji':
        lst[0]='fujifilm'
    if 'alibaba' in orig_title:
        orig_title= ' '.join(title[:8])
        #print (orig_title)
        title=title[:8]
        if 'case for' in orig_title or 'bag for' in orig_title:
            return (lst[0],'')
    if 'for' in orig_title and  'nikon' in orig_title  and 'alibaba' in orig_title:
        #print ("returning",orig_title)
        return (lst[0],'')
    if 'samyang' in orig_title or 'mavica cd1000' in orig_title:
        return (lst[0],'')
    #if 'body only' in orig_title:

    #    return (lst[0],'')
    #if 'case' in orig_title or 'cases' in orig_title or 'cover' in orig_title or 'body' in orig_title:
    #	return ('','')
    #if 'kodak cx6330' in orig_title:
    #    print (orig_title,"here it is" )
    if title[0]=='nikon' and (title[1]=='v2' or title[2]=='v2'):
        return (lst[0],'nikon v2')
    for model in models:
        if model in orig_title:
            return (lst[0],model)
        else:
            modelsplit=model.split()
            if 'om-d e-m' in model and ' '.join(modelsplit[1:]) in orig_title:
                return (lst[0],model)
                
            if modelsplit[0] in orig_title:
                if ' '.join(modelsplit[1:]) in orig_title or ''.join(modelsplit[1:]) in orig_title or '-'.join(modelsplit[1:]) in orig_title:
                    return (lst[0],model)
                elif ('cyber shot' in orig_title or 'cybershot' in orig_title) and ' '.join(modelsplit[2:]) in orig_title and 'cyber-shot' in model and len(modelsplit[2])>1:
                    return (lst[0],model)
                elif 'eos' in modelsplit and not 'powershot' in orig_title and (' '.join(modelsplit[2:]) in orig_title or ''.join(modelsplit[2:]) in orig_title) and len(modelsplit[2])>1:
                    return (lst[0],model)
                elif  len(modelsplit)>2 and ('powershot' in model and not 'eos' in orig_title and not 'rebel' in orig_title)  and (' '.join(modelsplit[2:]) in orig_title or ''.join(modelsplit[2:]) in orig_title or '-'.join(modelsplit[2:]) in orig_title) and len(modelsplit[2])>1:
                    return (lst[0],model)
                if 'eos rebel' in model and modelsplit[-1] in orig_title:
                    return (lst[0],model)
                found=True
                if model=='olympus xz 10' and ' xz 1 ' in orig_title:
                    continue
                #if 'om-d e-m5 16 0 mp camera silver w 1 4 42m' in orig_title:
                #    print (model+":"+orig_title)
                #if "olympus evolt e-510 with 14-42mm lens reviews - buzzilli" in orig_title:
                #    print (model+":"+orig_title)
        
                
                if not ('ixus' in model or 'elph' in model or 'nex' in model or 'powershot sd' in model  or 'olympus sh 50' in model):
                    iter=0
                    while iter<len(modelsplit):
                        token=modelsplit[iter]
                        if token in title:
                            iter+=1
                            continue
                        #elif iter<len(modelsplit)-1:
                        #    if modelsplit[iter]+modelsplit[iter+1] in title or modelsplit[iter]+'-'+modelsplit[iter+1] in title:
                        #        iter+=2
                        #        continue

                        else:

                            found=False
                            break

                        iter+=1
                
                    if found:
                        return (lst[0],model)
    #print (orig_title)
    #brand_index=title.index(lst[0])
    #if brand_index==len(title)-1:
    #    return (lst[0],'')
    '''print (title,brand_index)
    iter=brand_index
    while iter<len(title):
        if title[iter].isnumeric():
            break

        iter+=1
    print ("found number",iter)
    '''
    return (lst[0],'')#title[brand_index+1])
        #return (lst[0],title[brand_index+1])
    #if intersection is more than 1 it is an accessory
    # nikkor can be replaced by nikon


    '''
    for b in brand_lst:
        if b in title:
            if b=='nikkor':
                return 'nikon'
            return b
    '''
    return ('','')

def create_dataframe(dataset_path,models):
    """Function used to create a Pandas DataFrame containing specifications page titles

    Reads products specifications from the file system ("dataset_path" variable in the main function) and creates a Pandas DataFrame where each row is a
    specification. The columns are 'source' (e.g. www.sourceA.com), 'spec_number' (e.g. 1) and the 'page title'. Note that this script will consider only
    the page title attribute for simplicity.

    Args:
        dataset_path (str): The path to the dataset

    Returns:
        df (pd.DataFrame): The Pandas DataFrame containing specifications and page titles
    """

    #print('>>> Creating dataframe...\n')
    columns_df = ['source', 'spec_number', 'spec_id', 'page_title','brand','model','modelinside']

    progressive_id = 0
    progressive_id2row_df = {}
    count=0
    model_dic={}
    for source in (os.listdir(dataset_path)):
        for specification in os.listdir(os.path.join(dataset_path, source)):
            specification_number = specification.replace('.json', '')
            specification_id = '{}//{}'.format(source, specification_number)
            with open(os.path.join(dataset_path, source, specification)) as specification_file:
                specification_data = json.load(specification_file)
                page_title = specification_data.get('<page title>').lower().replace('(','')
                page_title=page_title.replace('cannon','canon')
                page_title=page_title.replace('nicon','nikon')
                page_title=page_title.replace('fuijifilm','fujifilm')
                page_title=page_title.replace('fiji','fujifilm')
                if 'fuj' in page_title:
                    page_title=page_title.replace('fujufilm','fujifilm')
                    page_title=page_title.replace('fujifim','fujifilm')
                    page_title=page_title.replace('fuji','fujifilm')
                
                elif 'olympu' in page_title:
                    page_title=page_title.replace('olympul','olympus')
                
                page_title=page_title.replace('fugi','fujifilm')
                page_title=page_title.replace('fume film','fujifilm')
                page_title=page_title.replace('polarold','polaroid')

                page_title=page_title.replace('g1x','g1 x')
                page_title=page_title.replace('x-s1','xs1')
                page_title=page_title.replace('film xs-1','film xs1')
                page_title=page_title.replace(' x s1',' xs1')
                page_title=page_title.replace('+',' ')
                
                page_title=page_title.replace('mk ii','mark ii')
                page_title=page_title.replace('mkii','mark ii')
                page_title=page_title.replace('mk 2','mark ii')
                page_title=page_title.replace('mark 2','mark ii')
                page_title=page_title.replace('markii','mark ii')
                page_title=page_title.replace('mark ii n','mark iinew')

                page_title=page_title.replace('mk iii','mark iii')
                page_title=page_title.replace('mkiii','mark iii')
                page_title=page_title.replace('mk 3','mark iii')
                page_title=page_title.replace('mark 3','mark iii')

                page_title=page_title.replace('mk iv','mark iv')
                page_title=page_title.replace('mkiv','mark iv')
                page_title=page_title.replace('mk 4','mark iv')
                page_title=page_title.replace('mark 4','mark iv')

                page_title=page_title.replace('rx100m3','rx100 iii')
                page_title=page_title.replace('rx100m2','rx100 ii')

                
                page_title=page_title.replace('olympus e 3 ','olympus e-3 ')
                page_title=page_title.replace(' ep 2 ',' ep2 ')
                
                page_title=page_title.replace('eos rebel t 3 ','eos rebel t3 ')
                page_title=page_title.replace('sony ilce-3000K','sony a3000')
                page_title=page_title.replace('rx100 ii','rx100ii')
                page_title=page_title.replace('sony ilce 3000','sony a3000')


                
                
                page_title=page_title.replace('x-pro 1','x pro1')

                
                if 'sony' in page_title:
                    page_title=page_title.replace('ilce ','a')
                    page_title=page_title.replace('ilce-','a')                
                    page_title=page_title.replace('alpha-','a')
                    page_title=page_title.replace('alpha ','a')
                    page_title=page_title.replace('kodax','kodak')
                    page_title=page_title.replace('5 d mark ii','5d mark ii')
                elif 'olympus' in page_title:
                    page_title=page_title.replace('om d e m1','om-d e-m1')
                    page_title=page_title.replace('omd e m 1','om-d e-m1')
                    page_title=page_title.replace('omd e m1','om-d e-m1')
                    page_title=page_title.replace('om d e m5','om-d e-m5')
                    page_title=page_title.replace('omd em5','om-d e-m5')
                    page_title=page_title.replace('om d em 1','om-d e-m1')
                    page_title=page_title.replace('olympus om d em 5','om-d e-m5')
                    page_title=page_title.replace(' e p5 ',' pen e-p5')
                    page_title=page_title.replace('olympus evolt e-510 ','olympus evolt 510 ')
                    page_title=page_title.replace('olympus camedia d 360 ','olympus evolt 360 ')
                    
                elif 'nikon' in page_title:
                    page_title=page_title.replace('nikon coolpix 01','nikon coolpix s01')
                    page_title=page_title.replace('nikon 1 v 1','nikon 1 v1')
                    page_title=page_title.replace('nikon d 80 ','nikon d80 ')
                    page_title=page_title.replace('nikon d 3s ','nikon d3s ')
                    page_title=page_title.replace('coolpix l 24 ','coolpix l24 ')
                    
                elif 'canon' in page_title:
                    page_title=page_title.replace('canon eos digital rebel 6','canon eos ds6041')
                    page_title=page_title.replace('canon eos 60 d ','canon eos 60d ')
                    page_title=page_title.replace('canon eos 5 d ','canon eos 5d ')
                    page_title=page_title.replace('canon 5 d ','canon eos 5d ')
                    page_title=page_title.replace('canon eos 40 d ','canon eos 40d ')
                    page_title=page_title.replace('canon eos 1 ds ','canon eos 1ds ')
                    page_title=page_title.replace('canon eos 1 d ','canon eos 1d ')
                    page_title=page_title.replace('canon eos 1 dx ','canon eos 1d x ')
                    
                 
                (brand,model)=get_brand(page_title,models)
                if len(model)==0:
                    continue
                lst=[]
                if model in model_dic.keys():
                    lst=model_dic[model]
                lst.append(specification_id)
                model_dic[model]=lst
                '''if 'alibaba' in page_title:
                    print (page_title+":"+model)
                else:
                    continue
                '''
                #if "camouflage vna593e1)" in page_title:
                #    jkfsd
                #if model=='sony h2':
                #    print (page_title)
                #modelinside=specification_data.get('model')#.lower().replace('(','')#model id
                #if len(model)==0:# is None:
                #    print (page_title)
                #else:
                #s	continue
                '''if  not 'alibaba' in page_title and len(model)==0:
                	print (page_title,":",model)
                else:
                    continue
                '''
                #if (brand=='samsung' ) and len(model)==0:
                #    print (page_title+":"+model)
                #else:
                #    continue 
                #row = (source, specification_number, specification_id, page_title,brand,model,modelinside)
                #progressive_id2row_df.update({progressive_id: row})
                progressive_id += 1
    #df = pd.DataFrame.from_dict(progressive_id2row_df, orient='index', columns=columns_df)
    #kjflds
    #print(df)
    #print('>>> Dataframe created successfully!\n')
    #print (count)
    return model_dic

def get_high_preicion_mathces(model_dic,models,matches,vallst):
    columns_df = ['left_spec_id', 'right_spec_id']
    #matching_pairs_df = pd.DataFrame(columns=columns_df)
    #uniq_models=df.model.unique()
    fout=open('output/submission.csv','w')
    fout.write('left_spec_id,right_spec_id\n')
    total_nodes=0
    for m in models:
        #print (m)
        if m=='case for panasonic':# or m=='leica c' or m=='panasonic lumi x' or 'panasonic' in m:
            continue
        if len(m)==0:
            #print (m)
            continue
        if m in vallst:
            continue
        #if not ('canon' in m or 'olympus' in m  or 'fujifilm' in m or 'canon' in m or 'nikon' in m or 'sony' in m):
        #    continue
        if not m in model_dic.keys():
            continue
        tmpdf=model_dic[m]

        #tmpdf=model_dic[m]
        if m in matches.keys():
            #print ("found ",matches[m])
            if matches[m] in model_dic.keys():
                tmpdf.extend(model_dic[matches[m]])
        #elif m=='canon 500d':
        #    tmpdf.extend(model_dic['canon eos rebel t1i'])#])
        #elif m=='canon powershot sd 870':
        #    tmpdf.extend(model_dic['canon ixus 860 is'])
        #elif m=='canon eos 700d':
        #    tmpdf.extend(model_dic['canon eos rebel t5i'])
        #    #tmpdf.extend(model_dic['canon eos kiss x7i'])
        #elif m=='canon 600d':
        #    tmpdf.extend(model_dic['canon eos rebel t3i'])
        

        elif m=='canon eos 100d':
            tmpdf.extend(model_dic['canon eos rebel sl1'])
            tmpdf.extend(model_dic['canon eos kiss x7'])
        #elif m=='canon eos d2000':
        #    tmpdf.extend(model_dic['canon eos 1n'])
        
        if m=='canon eos rebel sl1' or m=='canon eos kiss x7': 
            continue
            #if len(tmpdf)>100:
        
        total_nodes+=len(tmpdf)
        #if len(tmpdf)>0:
        #    continue
        i=0
        while i<len(tmpdf):
            j=i+1
            #print (tmpdf[i])
            #print_features1(tmpdf[i],df)
            
            #if len(tmpdf[i])>1:
            #    i+=1
            #    continue
            while j<len(tmpdf):
                fout.write(tmpdf[i]+","+ tmpdf[j]+"\n")
                #matching_pair_row = pd.Series([tmpdf[i], tmpdf[j]], columns_df) 
                #matching_pairs_df = matching_pairs_df.append(matching_pair_row, ignore_index=True)
                j+=1

            i+=1
    fout.close()
    #print ("total records",total_nodes)
    return #matching_pairs_df



def generate_blocks(df):

    print('>>> Computing blocking...')
    blocking_keys = []
    blocks={}
    block_size={}
    sorted_size=[]

    #generate a hierarchy of blocks


    for index, row in tqdm(df.iterrows()):
        page_title = list(set(row['page_title'].split()))

        i=0
        while i<len(page_title):
            j=i+1
            curr=page_title[i]
            lst=[]
            if curr in blocks.keys():
                lst=blocks[curr]
            else:
                blocking_keys.append(curr) 
                block_size[curr]=0 
            lst.append(index)
            blocks[curr]=lst
            block_size[curr]+=1

            while j<len(page_title):
                if j>i+5:
                    break
                curr+='|'+page_title[j]
                lst=[]
                if curr in blocks.keys():
                    lst=blocks[curr]
                else:
                    blocking_keys.append(curr) 
                    block_size[curr]=0 
                lst.append(index)
                blocks[curr]=lst
                block_size[curr]+=1

                j+=1
            
            i+=1

        '''
        for token in page_title:
            lst=[]
            if token in blocking_keys:
                lst=blocks[token]
            else:
                blocking_keys.append(token) 
                block_size[token]=0   
            lst.append(index)
            blocks[token]=lst
            block_size[token]+=1

        '''
    sorted_size = sorted(block_size.items(), key=operator.itemgetter(1))
    print ("number of blocks",len(blocking_keys))   

    return (blocking_keys,blocks,block_size,sorted_size)
def run_ER(df,blocking_keys,blocks,block_size,sorted_size):
    columns_df = ['left_spec_id', 'right_spec_id']
    matching_pairs_df = pd.DataFrame(columns=columns_df)
    processed={}
    iter=0
    total=0
    for (token,val) in tqdm(sorted_size):
        if val>20:
            print ("total blocks processed",iter)
            break
        iter+=1
        lst= (blocks[token])
        i=0
        while i<len(lst):
            j=i+1
            while j<len(lst):
                if (lst[i],lst[j])in processed.keys() or (lst[j],lst[i]) in processed.keys():
                    j+=1
                    continue
                matching_pair_row=compute_matching (lst[i],lst[j],df)
                total+=1
                if len(matching_pair_row)>0:
                    matching_pairs_df = matching_pairs_df.append(matching_pair_row, ignore_index=True)
                processed[(lst[i],lst[j])]=1
                j+=1
            i+=1
    print(matching_pairs_df.head(5))
    print('>>> Matching computed successfully!\n',total)
    return matching_pairs_df


def compute_matching_based_on_specids(leftid,rightid,df):
    leftrow=df.loc[df['spec_id'] == leftid]
    rightrow=df.loc[df['spec_id'] == rightid]
    columns_df = ['left_spec_id', 'right_spec_id']
    
    #print (left_spec_title)
    #print (right_spec_title)
    #left_tokens = set(left_spec_title.split()[:3])
    #right_tokens = set(right_spec_title.split()[:3])
    #left_brand=leftrow.loc[df['spec_id'] == leftid,'brand'].values[0]
    #right_brand=rightrow.loc[df['spec_id'] == rightid,'brand'].values[0]

    left_model=leftrow.loc[df['spec_id'] == leftid,'model'].values[0]
    right_model=rightrow.loc[df['spec_id'] == rightid,'model'].values[0]
    if 'eos' in left_model and 'eos' in right_model:
        left_spec_title =leftrow.loc[df['spec_id'] == leftid,'page_title'].values[0]
        right_spec_title = rightrow.loc[df['spec_id'] == rightid,'page_title'].values[0]
        print (left_spec_title+":"+right_spec_title)
    #print (left_model)
    #print (right_model,"model")
    if len(left_model)>0 and left_model==right_model:#len(left_tokens.intersection(right_tokens)) >= 2:
    #if left_brand ==right_brand   and left_model==right_model:#len(left_tokens.intersection(right_tokens)) >= 2:
        matching_pair_row = pd.Series([leftid, rightid], columns_df)
        return matching_pair_row

    return ''
def compute_matching (leftid,rightid,df):

    columns_df = ['left_spec_id', 'right_spec_id']

    left_spec_title = df.loc[leftid,'page_title']
    right_spec_title = df.loc[rightid,'page_title']
    left_tokens = set(left_spec_title.split()[:3])
    right_tokens = set(right_spec_title.split()[:3])
    left_brand=df.loc[leftid,'brand']
    right_brand=df.loc[rightid,'brand']

    if left_brand ==right_brand  and len(left_tokens.intersection(right_tokens)) >= 2:
        left_spec_id = df.loc[leftid,'spec_id']
        right_spec_id = df.loc[rightid,'spec_id']
        matching_pair_row = pd.Series([left_spec_id, right_spec_id], columns_df)
        return matching_pair_row

    return ''

    #    matching_pairs_df = matching_pairs_df.append(matching_pair_row, ignore_index=True)
    #print(matching_pairs_df.head(5))
    #print('>>> Matching computed successfully!\n')
    #return matching_pairs_df

def compute_matching2(pairs_df):
    """Function used to actually compute the matching specifications

    Iterates over the pairs DataFrame and uses a matching function to decide if they represent the same real-world
    product or not. Two specifications are matching if they share at least 2 tokens in the page title.
    The tokenization is made by simply splitting strings by using blank character as separator.

    Args:
        df (pd.DataFrame): The Pandas DataFrame containing pairs of specifications

    Returns:
        matching_pairs_df (pd.DataFrame): The Pandas DataFrame containing the matching pairs
    """

    print('>>> Computing matching...\n')
    columns_df = ['left_spec_id', 'right_spec_id']
    matching_pairs_df = pd.DataFrame(columns=columns_df)
    for index, row in tqdm(pairs_df.iterrows()):
        left_spec_title = row['left_spec_title']
        right_spec_title = row['right_spec_title']
        left_tokens = set(left_spec_title.split())
        right_tokens = set(right_spec_title.split())

        if len(left_tokens.intersection(right_tokens)) >= 2:
            left_spec_id = row['left_spec_id']
            right_spec_id = row['right_spec_id']
            matching_pair_row = pd.Series([left_spec_id, right_spec_id], columns_df)
            matching_pairs_df = matching_pairs_df.append(matching_pair_row, ignore_index=True)
    print(matching_pairs_df.head(5))
    print('>>> Matching computed successfully!\n')
    return matching_pairs_df

def print_features1(leftid,df):
    leftrow=df.loc[df['spec_id'] == leftid]
    left_spec_title =leftrow.loc[df['spec_id'] == leftid,'page_title'].values[0]
    left_tokens = set(left_spec_title.split()[:3])

    left_brand=leftrow.loc[df['spec_id'] == leftid,'brand'].values[0]

    left_model=leftrow.loc[df['spec_id'] == leftid,'model'].values[0]

    left_modelinside=leftrow.loc[df['spec_id'] == leftid,'modelinside'].values[0]

    print ("new features")
    print (left_brand)
    print (left_model)
    print (left_modelinside)
    print (left_spec_title)
def print_features(leftid,rightid,df):
    leftrow=df.loc[df['spec_id'] == leftid]
    rightrow=df.loc[df['spec_id'] == rightid]
    columns_df = ['left_spec_id', 'right_spec_id']
    print (leftid,rightid)
    #print(leftrow)
    #print(rightrow)
    try:
        left_spec_title =leftrow.loc[df['spec_id'] == leftid,'page_title'].values[0]
        right_spec_title = rightrow.loc[df['spec_id'] == rightid,'page_title'].values[0]

        #print (left_spec_title)
        #print (right_spec_title)
        left_tokens = set(left_spec_title.split()[:3])
        right_tokens = set(right_spec_title.split()[:3])
        left_brand=leftrow.loc[df['spec_id'] == leftid,'brand'].values[0]
        right_brand=rightrow.loc[df['spec_id'] == rightid,'brand'].values[0]
        #if left_brand=='panasonic' and right_brand=='panasonic':
        #    return
        left_model=leftrow.loc[df['spec_id'] == leftid,'model'].values[0]
        right_model=rightrow.loc[df['spec_id'] == rightid,'model'].values[0]

        #if  left_model==right_model or len(left_model)==0 or len(right_model)==0:
        #if not "alibaba" in left_spec_title:
        print ("new features")
        print ("brand",left_brand,right_brand)
        print ("model",left_model,":",right_model)
        print ("title",left_spec_title,right_spec_title)
    except:
        return

def read_validation(df):
    #val_df=pd.read_csv('sigmod_large_labelled_dataset.csv')
    val_df=pd.read_csv('output/shuffled.csv')#oracles_answers-2019_05_16.csv')
    #val_df.reindex(np.random.permutation(val_df.index))
    
    print (val_df.head())
    count=0
    tp=0
    fp=0
    fn=0
    total=0
    for index, row in tqdm(val_df.iterrows()):
        left_spec_id = row['left_spec_id']
        right_spec_id = row['right_spec_id']
        #label=row['label']
        #print (row)
        #if  not label=='True':
        #print (row)
        print_features(left_spec_id,right_spec_id,df)
            #if index>500:
            #    break
        '''
        if label==1:
            #print (index)
            #print (row)
            l=len(compute_matching_based_on_specids(left_spec_id,right_spec_id,df))
            if l>0:
                count+=1
                tp+=1
            else:
                #print (row)
                #print_features(left_spec_id,right_spec_id,df)
                fn+=1
            if total%100==0:
                print ("totalis",total)
            total+=1
        else:
            l=len(compute_matching_based_on_specids(left_spec_id,right_spec_id,df))
            if l>0:
                fp+=1
                print (row)
                print_features(left_spec_id,right_spec_id,df)
        if total>5000:
            break
        '''
    #print ("\n")
    #print (tp*1.0/(tp+fp),tp*1.0/(tp+fn))
    #print (count,total)



def read_diff(df):
    val_df=pd.read_csv('output/diff.csv')
    print (val_df.head())
    count=0
    tp=0
    fp=0
    fn=0
    total=0
    for index, row in tqdm(val_df.iterrows()):
        left_spec_id = row['0']#left_spec_id']
        right_spec_id = row['1']#right_spec_id']

        #print (row)
        print_features(left_spec_id,right_spec_id,df)
        #label=row['label']
        '''
        if label==1:
            print (row)
            print_features(left_spec_id,right_spec_id,df)
            if index>500:
                break
        '''



"""
    This script will:
    1. create a Pandas DataFrame for the dataset. Note that only the <page title> attribute is considered (for example purposes);
    2. partition the rows of the Pandas DataFrame in different blocks, accordingly with a blocking function;
    3. create a Pandas DataFrame for all the pairs computed inside each block;
    4. create a Pandas DataFrame containing all the matching pairs accordingly with a matching function;
    5. export the Pandas DataFrame containing all the matching pairs in the "outputh_path" folder.
"""
if __name__ == '__main__':
    dataset_path = '../2013_camera_specs'
    outputh_path = './output'

    matches={}
    vallst=[]

    models={}
    f=open('models.txt')
    found_matches=False
    for line in f:
        line=line.strip().lower()
        #if not ('canon' in line or 'olympus' in line  or 'fujifilm' in line or 'canon' in line or 'nikon' in line or 'sony' in line):
        #    continue
        if line=='matches':
            found_matches=True
            continue
        if found_matches:
            line=line.split(':')
            if len(line)==1:
                continue
            matches[line[0].strip()]=line[1].strip()
            vallst.append(line[1].strip())
        else:
            models[line]=1

    model_dic = create_dataframe(dataset_path,models)
    #(dataset_df.groupby('brand').count().to_csv('counts'))

    #jkl
    
    #output_df=get_high_brands(dataset_df)
    output_df=get_high_preicion_mathces(model_dic,models,matches,vallst)

